import { IPopulation, IFitness, ISelection, ICrossover, IMutation, IReinsertion, IIsland } from '..';
export declare abstract class IslandBase implements IIsland {
    protected _generationNumber: number;
    protected _offspringNumber: number;
    private _initialized;
    get generationNumber(): number;
    get offspringNumber(): number;
    get initialized(): boolean;
    abstract get population(): IPopulation;
    abstract get fitness(): IFitness;
    abstract get selection(): ISelection;
    abstract get crossover(): ICrossover;
    abstract get crossoverProbability(): number;
    abstract get mutation(): IMutation;
    abstract get mutationProbability(): number;
    abstract get reinsertion(): IReinsertion;
    reset(): Promise<void>;
    protected performReset(): void;
    step(): Promise<void>;
    protected performStep(): void;
}
